searchData={"items":[{"type":"module","title":"Tulle.HTTP","doc":"Make HTTP requests with a `Tulle.HTTP1.Client` or `Tulle.HTTP2.Client`.","ref":"Tulle.HTTP.html"},{"type":"function","title":"Tulle.HTTP.close_request!/1","doc":"Sends EOF for the collectable returned by `request_collectable!/2`.\n\nReturns a triple of the status, the headers, and the response body stream.","ref":"Tulle.HTTP.html#close_request!/1"},{"type":"function","title":"Tulle.HTTP.get_info/1","doc":"Get the custom data that was put with `set_info/2`","ref":"Tulle.HTTP.html#get_info/1"},{"type":"function","title":"Tulle.HTTP.request!/4","doc":"Sends a request. Returns a triple of the status, the headers, and the response body stream.","ref":"Tulle.HTTP.html#request!/4"},{"type":"function","title":"Tulle.HTTP.request_collectable!/2","doc":"Start a streaming request.\n\nThe returned `t:request/0` object can be `Enum.into/2`'ed.\nCall `close_request!/1` to signal the EOF.","ref":"Tulle.HTTP.html#request_collectable!/2"},{"type":"function","title":"Tulle.HTTP.set_info/2","doc":"Put arbitrary custom data that can be accesses with `get_info/1`","ref":"Tulle.HTTP.html#set_info/2"},{"type":"type","title":"Tulle.HTTP.client/0","doc":"A `Tulle.HTTP1.Client` or `Tulle.HTTP2.Client` or process.","ref":"Tulle.HTTP.html#t:client/0"},{"type":"type","title":"Tulle.HTTP.req_params/1","doc":"Method-path-header triple.\n\nreq_params(atom) would indicate method can be either a string or atom.","ref":"Tulle.HTTP.html#t:req_params/1"},{"type":"opaque","title":"Tulle.HTTP.request/0","doc":"A `Collectable` that writes to an HTTP request stream.\n\nCreated with `request_collectable!/2`.\nWhen done sending, `close_request!/1` must be called to signal the EOF.","ref":"Tulle.HTTP.html#t:request/0"},{"type":"module","title":"Tulle.HTTP1.Client","doc":"HTTP1 Client. Used with `Tulle.HTTP`.\n\nKeeps the HTTP connection open\nTries to reconnect when the connection is lost,\nexits if it can't reconnect with `{:cant_connect, reason}`","ref":"Tulle.HTTP1.Client.html"},{"type":"function","title":"Tulle.HTTP1.Client.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Tulle.HTTP1.Client.html#child_spec/1"},{"type":"function","title":"Tulle.HTTP1.Client.start_link/1","doc":"","ref":"Tulle.HTTP1.Client.html#start_link/1"},{"type":"type","title":"Tulle.HTTP1.Client.http1_client/0","doc":"","ref":"Tulle.HTTP1.Client.html#t:http1_client/0"},{"type":"module","title":"Tulle.HTTP1.Pool","doc":"Pool for holding `Tulle.HTTP1.Client` processes.\n\nIn current implementation,\nat least one connection (one process) is kept open.\nIdle processes are shutdown with a half-life of\n60 seconds.","ref":"Tulle.HTTP1.Pool.html"},{"type":"function","title":"Tulle.HTTP1.Pool.check_in/2","doc":"Returns a checked-out `Tulle.HTTP1.Client` back to the pool.","ref":"Tulle.HTTP1.Pool.html#check_in/2"},{"type":"function","title":"Tulle.HTTP1.Pool.check_out!/2","doc":"Check-out a `Tulle.HTTP1.Client` process from the pool,\nspawning if necessary.","ref":"Tulle.HTTP1.Pool.html#check_out!/2"},{"type":"function","title":"Tulle.HTTP1.Pool.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Tulle.HTTP1.Pool.html#child_spec/1"},{"type":"function","title":"Tulle.HTTP1.Pool.start_link/1","doc":"","ref":"Tulle.HTTP1.Pool.html#start_link/1"},{"type":"type","title":"Tulle.HTTP1.Pool.pool/0","doc":"","ref":"Tulle.HTTP1.Pool.html#t:pool/0"},{"type":"type","title":"Tulle.HTTP1.Pool.worker/0","doc":"","ref":"Tulle.HTTP1.Pool.html#t:worker/0"},{"type":"module","title":"Tulle.HTTP2.Client","doc":"HTTP2 Client. Used with `Tulle.HTTP`.","ref":"Tulle.HTTP2.Client.html"},{"type":"function","title":"Tulle.HTTP2.Client.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Tulle.HTTP2.Client.html#child_spec/1"},{"type":"function","title":"Tulle.HTTP2.Client.start_link/1","doc":"","ref":"Tulle.HTTP2.Client.html#start_link/1"},{"type":"type","title":"Tulle.HTTP2.Client.http2_client/0","doc":"","ref":"Tulle.HTTP2.Client.html#t:http2_client/0"},{"type":"behaviour","title":"Tulle.Websocket","doc":"Websocket client, implemented as a Genserver.\n\n`use`'ing this module defines a `child_spec` functions,\nand defines `@behaviour Tulle.Websocket`.","ref":"Tulle.Websocket.html"},{"type":"function","title":"Tulle.Websocket.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Tulle.Websocket.html#child_spec/1"},{"type":"function","title":"Tulle.Websocket.close/2","doc":"","ref":"Tulle.Websocket.html#close/2"},{"type":"callback","title":"Tulle.Websocket.handle_connect/1","doc":"","ref":"Tulle.Websocket.html#c:handle_connect/1"},{"type":"callback","title":"Tulle.Websocket.handle_in/2","doc":"","ref":"Tulle.Websocket.html#c:handle_in/2"},{"type":"callback","title":"Tulle.Websocket.handle_remote_close/3","doc":"","ref":"Tulle.Websocket.html#c:handle_remote_close/3"},{"type":"function","title":"Tulle.Websocket.send/3","doc":"","ref":"Tulle.Websocket.html#send/3"},{"type":"function","title":"Tulle.Websocket.start_link/4","doc":"","ref":"Tulle.Websocket.html#start_link/4"},{"type":"type","title":"Tulle.Websocket.code/0","doc":"","ref":"Tulle.Websocket.html#t:code/0"},{"type":"type","title":"Tulle.Websocket.conn_opts/0","doc":"Must have `:url`, optionally can have `:headers` and `:extensions`.\n(defaults to `PerMessageDeflate`).","ref":"Tulle.Websocket.html#t:conn_opts/0"},{"type":"type","title":"Tulle.Websocket.handle_result/0","doc":"","ref":"Tulle.Websocket.html#t:handle_result/0"},{"type":"type","title":"Tulle.Websocket.message/0","doc":"","ref":"Tulle.Websocket.html#t:message/0"}],"content_type":"text/markdown"}